import es, css_arpg, popuplib, services, playerlib
from css_arpg import css_arpg

def load():
    global adminmenu, admins, admin
    
    adminmenu = popuplib.create('adminmenu')
    a = adminmenu.addline
    b = adminmenu.select
    a('CS:S ARPG ADMIN MENU')
    a('[][][][][][][][][][][]')
    a('-> 1. Give Levels')
    a('-> 2. Give XP')
    a('-> 3. Give Credits')
    a('-> 4. Take Level\'s')
    a('-> 5. Take XP')
    a('-> 6. Take Credits')
    a('-> 7. Delete A Player')
    a('-> 8. Reset Levels')  
    if int(es.ServerVar('arpg_enableranks')):
        a('-> 9. Reset Ranks')
    a('-> 0. Exit')
    adminmenu.menuselect = adminselection
    
    
    # This is your admin list. Add any admins here
    admins = ['STEAM_0:0:8137505', 'STEAM_0:0:69414']
    
    es.unregclientcmd('arpgadmin')
    es.unregsaycmd('arpgadmin')
    es.regclientcmd('arpgadmin', 'css_arpg/arpgadmin/sendmain')
    es.regsaycmd('arpgadmin', 'css_arpg/arpgadmin/sendmain')
    
    auth_service = services.use('auth')
    auth_service.registerCapability('arpg_admin', auth_service.ADMIN)
    admin = lambda userid: auth_service.isUseridAuthorized(userid, 'arpg_admin')
    
def sendmain():
    if admin(es.getcmduserid()):
        css_arpg.Player(es.getcmduserid()) # Just to update their name        
        adminmenu.send(es.getcmduserid())
        
def adminselection(userid, choice, popupid):
    if choice in range(1,9):        
        if choice == 1:
            givelevels(userid)
        if choice == 2:
            givexp(userid)
        if choice == 3:
            givecredits(userid)
        if choice == 4:
            takelevels(userid)
        if choice == 5:
            takexp(userid)
        if choice == 6:
            takecredits(userid)
        if choice == 7:
            deletemenu(userid)
        if choice == 8:
            restart(userid)
        if choice == 9:
            ranks(userid)
            
def createAmountList(userid, target, function, *args):
    """ 
    This function creates a default set of values to make it 'easier' to choose a value. If the player
    wants a custom value, then they can choose the 'custom' option.
    """
    amountMenu = popuplib.easymenu('amountlist', '_popup_choice', sendFunctionWithValue)
    amountMenu.settitle('Select an amount')
    amountMenu.addoption([1,    function, target, args], "1"   )
    amountMenu.addoption([2,    function, target, args], "2"   )
    amountMenu.addoption([5,    function, target, args], "5"   )
    amountMenu.addoption([10,   function, target, args], "10"  )
    amountMenu.addoption([20,   function, target, args], "20"  )
    amountMenu.addoption([50,   function, target, args], "50"  )
    amountMenu.addoption([100,  function, target, args], "100" )
    amountMenu.addoption([1000, function, target, args], "1000")
    amountMenu.send(userid)
        
        
def sendFunctionWithValue(userid, choice, popupid):
    amount, function, target, args = choice
    if args:
        """ Okay we have some args, so send them unpacked """
        function(userid, target, amount, *args)
    else:
        """ No additional arguments, so we have no need to send any. """
        function(userid, target, amount)


####################################################################################################################
def givelevels(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, givelevels2)
    tempmenu.settitle('Pick A Player to give Levels:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)
    
def givelevels2(userid, choice, popupid):
    createAmountList(userid, choice, commandGiveLevel)
    
def commandGiveLevel(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givelevels(amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['level'] += int(amount)
    
####################################################################################################################

def givexp(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, givexp2)
    tempmenu.settitle('Pick A Player to give XP:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)

def givexp2(userid, choice, popupid):
    createAmountList(userid, choice, commandGiveXP)

def commandGiveXP(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givexp(amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['xp'] += int(amount)
    
####################################################################################################################    

def givecredits(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, givecredits2)
    tempmenu.settitle('Pick A Player to give Credits:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)

def givecredits2(userid, choice, popupid):
    createAmountList(userid, choice, commandGivecredits)

def commandGivecredits(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givecredits(amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['credits'] += int(amount)
    
####################################################################################################################    


####################################################################################################################
def takelevels(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, takelevels2)
    tempmenu.settitle('Pick A Player to take Levels:')
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)
    
def takelevels2(userid, choice, popupid):
    createAmountList(userid, choice, commandTakeLevel)
    
def commandTakeLevel(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givelevels(-amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['level'] += int(amount)
    if css_arpg.database[choice]['level'] < 1:
        css_arpg.database[choice]['level'] = 1
    
####################################################################################################################

def takexp(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, takexp2)
    tempmenu.settitle('Pick A Player to give XP:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)

def takexp2(userid, choice, popupid):
    createAmountList(userid, choice, commandTakeXP)

def commandTakeXP(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givexp(-amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['xp'] += int(amount)
    
####################################################################################################################    

def takecredits(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, takecredits2)
    tempmenu.settitle('Pick A Player to give Credits:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid']))
    tempmenu.send(userid)

def takecredits2(userid, choice, popupid):
    createAmountList(userid, choice, commandTakecredits)

def commandTakecredits(userid, choice, amount):
    for player in es.getUseridList():
        if playerlib.uniqueid(player) == choice:    
            css_arpg.Player(player).givecredits(-amount, 'the gods saw fit')
            return 0
    css_arpg.database[choice]['credits'] += int(amount)
    
####################################################################################################################    

def deletemenu(userid):
    tempmenu = popuplib.easymenu('tempmenu', None, delete)
    tempmenu.settitle('Pick A Player to Delete From Database:')
    x = 1
    for player in css_arpg.database:
        tempmenu.addoption('%s'%player, '%s %s Last Connected: %s days ago'%(css_arpg.database[player]['name'], css_arpg.database[player]['steamid'], css_arpg.database[player]['last connected'] / 86400))
    tempmenu.send(userid)
    
def delete(userid, choice, popupid):
    name = css_arpg.database[choice]['name']
    del css_arpg.database[choice]
    css_arpg.rpgMsg('player deleted', {'name':name})

def restart(userid):
    tempmenu = popuplib.create('tempmenu')
    tempmenu.addline('ARE YOU _SURE_ YOU WANT TO RESET THE DATABASE?!')
    for x in range(0,7):
        tempmenu.addline('-> %s NO'%x)
    tempmenu.addline('-> 7. Yes')
    tempmenu.addline('-> 8. Back')
    tempmenu.addline('-> 0. Exit')
    tempmenu.submenu(8, 'adminmenu')
    tempmenu.menuselect = deld
    tempmenu.send(userid)
    
def deld(userid, choice, popupid):
    if choice == 7:
        del css_arpg.database
        css_arpg.rpgMsg('database deleted')
        css_arpg.database = {}
    
def ranks(userid):
    tempmenu = popuplib.create('tempmenu')
    tempmenu.addline('ARE YOU _SURE_ YOU WANT TO RESET RANKS?!')
    for x in range(0,7):
        tempmenu.addline('-> %s NO'%x)
    tempmenu.addline('-> 7. Yes')
    tempmenu.addline('-> 8. Back')
    tempmenu.addline('-> 0. Exit')
    tempmenu.submenu(8, 'adminmenu')
    tempmenu.menuselect = delr
    tempmenu.send(userid)
    
def delr(userid, choice, popupid):
    if choice == 7:
        del css_arpg.ranks
        css_arpg.rpgMsg('ranks deleted')
        css_arpg.ranks = {}
        
        