import es, playerlib, cPickle, cfglib, math, langlib, path, os, popuplib, random, time
from path import path


info = es.AddonInfo()
info.name     = 'CS:S Alternative RPG'
info.version  = 'Beta 1.0'
info.basename = 'cssarpg'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'Spoonman184'

config = cfglib.AddonCFG(es.getAddonPath("css_arpg") + "/css_arpg.cfg")

config.text("******************************")
config.text("  CS:S ARPG SETTINGS")
config.text("*****************************")

menuCommand    = config.cvar("arpg_menu",  "arpgmenu", "Text used to open the main menu")
defaultLanguage= config.cvar("arpg_lang",        "en", "Default language used for messages")
enableranks    = config.cvar("arpg_enableranks",    0, "Enable the CS:S ARPG Ranking System")
freecredits    = config.cvar("arpg_freecredits",    0, "Amount of credits to give to new players")

pruning        = config.cvar("arpg_pruning",        14, "Days of inactivity before a player is automatically removed from database (0 disables)")

killxp         = config.cvar("arpg_killxp",         10, "Amount of XP Gained for killing a player")
headshotxp         = config.cvar("arpg_headshotxp",  5, "Amount of XP Gained for getting a headshot (0 Disables)")
killxpinc      = config.cvar("arpg_killxpinc",       0, "Amount of additional XP Gained for each level the attacker has")
roundxp        = config.cvar("arpg_roundxp",        15, "Amount of XP Gained for winning the round")       
roundxpinc     = config.cvar("arpg_roundxpinc",      0, "Amount of XP Gained for winning the round for each level the winner has")       

maxlevel       = config.cvar("arpg_maxlevel",        0, "Maximum level someone can achieve. 0 Disables (default = \"0\"")

levelxp        = config.cvar("arpg_levelxp",      1000, "Amount of XP needed times your current level to advance in level (levelxp * level = xpneeded)")

levelcredits   = config.cvar("arpg_levelcredits",    5, "Amount of credits gained every level")
levelcreditsinc= config.cvar("arpg_levelcreditsinc", 0,"Additional amount of credits gained per level (levelcredits + level * levelcreditsinc)")

plantbombxp    = config.cvar("arpg_plantbombxp",    15, "Amount of XP Gained for planting the bomb")
explodebombxp  = config.cvar("arpg_explodedbombxp", 20, "Amount of XP Gained for the bomb exploding")
defusedbombxp  = config.cvar("arpg_defusedbombxp",  35, "Amount of XP Gained for defusing the bomb")
hostagexp      = config.cvar("arpg_hostagexp",      10,"Amount of XP Gained for rescuing a hostage")
allhostagexp   = config.cvar("arpg_allhostagexp",   20, "Amount of XP Gained for rescuing all hostages")

teamattackxp   = config.cvar("arpg_teamattackxp",    1, "Amount of XP lost for attacking a team mate")
teamkillxp     = config.cvar("arpg_teamkillxp",     10, "Amount of XP lost for killing a team mate")
hostagekillxp  = config.cvar("arpg_hostagekillxp",  10, "Amount of XP lost for killing a hostage")
suicidexp      = config.cvar("arpg_suicidexp",      10, "Amount of XP lost for suiciding")
#Will add bots later
config.write()

default_language = 'en'

skill_list = []
skills = {}
''' Proposed method of doing skills

    skills[skill] = {
                        1:{
                            'cost':0,
                            'effectiveness':0
                            },
                        'maxlevel':10
                    }

'''
ranks = {}
''' Proposed method of doing ranks

    rank[player.get(userid)] = {
                                    "kills":0,
                                    "damage dealt":0,
                                    "rounds won":0
                                }
'''
database = {}
''' Proposed method of doing database/stats

    database[player.get(userid)] = {
                                    "skill 1":0, ....
                                    "database":0
                                }
'''     
     
def load():
    global text, database, ranks, arpgmenu, arpginfo, auth_service
    
    try:
        str_path = es.getAddonPath('css_arpg') + '/players.db'
        if os.path.isfile(str_path):
            file_users = open(str_path)
            database = cPickle.load(file_users)
            file_users.close()        
    except:
        rpgMsg('creating database')
    try:
        if int(es.ServerVar('arpg_enableranks')):
            str_path = es.getAddonPath('css_arpg') + '/ranks.db'
            if os.path.isfile(str_path):
                file_users = open(str_path)
                ranks = cPickle.load(file_users)
                file_users.close()
    except:
        rpgMsg('creating ranks')
            
    x = path(es.getAddonPath('css_arpg'))
    for script in x.walkfiles():
        if script.ext == '.py' and 'init' not in script.name and 'css_arpg' not in script.name:    
            y = 'css_arpg/%s'%(script.namebase)
            es.reload(y)
            from damage import damage
    
        
    lang_path = es.getAddonPath('css_arpg') + '/strings.ini'
    if os.path.isfile(lang_path):
        text = langlib.Strings(es.getAddonPath('css_arpg') + '/strings.ini')
    else:
        es.msg("#multi#greenCS:S ARPG: ERROR#default: Unable to load strings.ini! Please ensure it is in the ./css_rpg/ directory.")
        
    config.execute()
    
    arpgmenu = popuplib.create('arpgmenu')
    arpgmenu.addline('CS:S Alternative RPG Menu')
    arpgmenu.addline('[][][][][][][][][][][]')
    arpgmenu.addline('-> 1. Purchase A Skill')
    arpgmenu.addline('-> 2. Read Skill Information')
    arpgmenu.addline('-> 3. CS:SS ARPG Info')
    arpgmenu.addline('-> 4. My Stats')
    arpgmenu.addline('-> 5. Player Info')    
    if int(es.ServerVar("arpg_enableranks")):
        arpgmenu.addline('-> 6. Ranks')
    arpgmenu.addline('-> 7. Sell A Skill')
    arpgmenu.addline('-> 0. Exit')
    arpgmenu.submenu(2, 'arpginfo')
    arpgmenu.menuselect = arpgmenuselect
    
    arpginfo = popuplib.create('arpginfo')
    arpginfo.addline('CS:S Alternative RPG Info')
    arpginfo.addline('[][][][][][][][][][][]')
    arpginfo.addline('As you play the game, you')
    arpginfo.addline('gain experience. Once you')
    arpginfo.addline('gain enough experience, you')
    arpginfo.addline('advance in level and gain')
    arpginfo.addline('credits you can use to')
    arpginfo.addline('purchase skills which')
    arpginfo.addline('aid you in game.')
    arpginfo.addline('-> 8. Main Menu')
    arpginfo.submenu(8, 'arpgmenu')
    
    es.unregsaycmd(es.ServerVar('arpg_menu'))
    es.regsaycmd(es.ServerVar('arpg_menu'), 'css_arpg/sendmenu')
    
    # This was for debugging my code. Please use the Admin System if you wish to give yourself Levels/Credits/XP
    #es.unregsaycmd('cheat')
    #es.regsaycmd('cheat', 'css_arpg/cheat')
    
    # This makes sure each player is in the database and rank system whenever the script is loaded
    # This does not mean that a player IS ranked when the script is loaded
    for userid in es.getUseridList():
        Player(userid)         
    if int(es.ServerVar('arpg_enableranks')):
        for userid in es.getUseridList():
            Rank(userid)
        
def player_activate(ev):
    Player(ev['userid'])
    
def round_start():
    x = float(es.ServerVar('est_version'))
    if not x:
        es.msg('WARNING!!!: SOME SKILLS REQUIRE ES_TOOLS!!!')
    
def sendmenu():
    global arpgmenu
    arpgmenu.send(es.getcmduserid())
    
def arpgmenuselect(userid, choice, popupid):
    if choice not in [9,0]:
        if choice == 1:
            arpgskills = popuplib.easymenu('arpgskills', '_popup_choice', buyskillfunction)
            arpgskills.settitle('CS:S Alternative RPG Skills\n[][][][][][][][][][][]\nAvailable Credits: %s'%Player(userid).credits)
            for x in skills:
                if Player(userid).skill(x) == skills[x]['maximum level']:
                    pass
                else:
                    arpgskills.addoption(x, '%s %s Credit(s)'%(x, skills[x]['Level %s'%(Player(userid).skill(x) + 1)]['cost']))
            arpgskills.send(userid)
        if choice == 2:
            arpgskills = popuplib.easymenu('arpgskills', '_popup_choice', infoskill)
            arpgskills.settitle('CS:S Alternative RPG Skills\n[][][][][][][][][][][]\n')
            for x in skills:
                arpgskills.addoption(x, x)
            arpgskills.send(userid)
        if choice == 4:
            Player(userid).query_player()
            tempmenu = popuplib.easymenu('My Skills', None, None)
            tempmenu.addoption(1, 'Level %s XP %s Credits %s'%(Player(userid).level,Player(userid).xp, Player(userid).credits))
            tempmenu.addoption(2, '--------------------------')
            for x in skills:
                tempmenu.addoption(x, '%s Level %s'%(x, Player(userid).skill(x)))
            tempmenu.send(userid)
        if choice == 5:
            tempmenu = popuplib.create('tempmenu')
            tempmenu.addline('Which players info do you want to see?')
            tempmenu.addline('-> 1. An Online Player')
            tempmenu.addline('-> 2. All Players')
            tempmenu.addline('-> 8. Main Menu')
            tempmenu.submenu(8, 'arpgmenu')
            tempmenu.menuselect = playerinfos
            tempmenu.send(userid)
        if choice == 6:
            if int(es.ServerVar("arpg_enableranks")):
                rankmenu = popuplib.easymenu('Ranks', '_popup_choice', rankselect)
                x = 1
                for player in ranks:
                    if 'rank' in ranks[player]:
                        if ranks[player]['rank'] == x:
                            rankmenu.addoption(player, ranks[player]['name'])
                    x += 1
                rankmenu.send(userid)
        if choice == 7:
            y = 0
            sales = {}
            for x in skills:
                if Player(userid).skill(x):
                    if skills[x]['Level %s'%Player(userid).skill(x)]['cost'] / 2:
                        sales[x] = skills[x]['Level %s'%Player(userid).skill(x)]['cost'] / 2
                    else:
                        sales[x] = 1
            if sales:
                tempmenu = popuplib.easymenu('Skills sell for half-value', None, sellskill)
                for x in sales:
                    tempmenu.addoption(x, 'Sell %s For %s Credits'%(x, sales[x]))
                tempmenu.send(userid)
            else:
                rpgTell(userid, 'no skills')
                
def sellskill(userid, choice, popupid):
    Player(userid).sell(choice)

def rankselect(userid, choice, popupid):
    if choice != 0:
        playerinfo = popuplib.create('playerinfo')
        playerinfo.addline("%s's Rank Info:"%ranks[choice]['name'])
        playerinfo.addline("Rank: %s"%ranks[choice]['rank'])
        playerinfo.addline('Kills: %s Deaths: %s'%(ranks[choice]['kills'],ranks[choice]['deaths']))
        playerinfo.addline('Damage Given: %s'%ranks[choice]['damage dealt'])
        playerinfo.addline('Damage Taken: %s'%ranks[choice]['damage taken'])
        playerinfo.addline('Rounds Won: %s Rounds Lost: %s'%(ranks[choice]['rounds won'], ranks[choice]['rounds lost']))
        playerinfo.addline('Score: %s'%ranks[choice]['score'])
        playerinfo.send(userid)
            
def buyskillfunction(userid, choice, popupid):
    Player(userid).buy(choice)
    
def infoskill(userid, choice, popupid):
    if choice != 0:
        infoskillmenu = popuplib.create('infoskillmenu')
        a = infoskillmenu.addline
        a('CS:S ARPG %s'%choice)
        a('[][][][][][][][][][][]')
        a(skills[choice]['information'])
        if not Player(userid).skill(choice) == skills[choice]['maximum level']:
            a('Costs %s Credits'%(skills[choice]['Level %s'%(Player(userid).effect(choice) + 1)]['cost']))
        else:
            a('MAXED')
        a('-> 8. Main Menu')
        infoskillmenu.submenu(8, 'arpgmenu')
        infoskillmenu.send(userid)
            
def rpgMsg(reason, vars={}):
    if vars:
        es.msg('#multi',text(reason, vars, es.ServerVar('arpg_lang')))
    else:
        es.msg('#multi',text(reason, lang=es.ServerVar('arpg_lang')))
        
def rpgTell(userid, reason, vars={}):
    language = playerlib.getPlayer(userid).get('lang')
    if vars:
        es.tell(userid, '#multi', text(reason, vars, language))
        return 0
    else:
        es.tell(userid, '#multi', text(reason, lang=language))
        return 0
        
def playerinfos(userid, choice, popupid):
    if choice == 1:
        infos = popuplib.easymenu('Choose A Player', None, buildinfomenu)
        for userid in es.getUseridList():
            infos.addoption(playerlib.uniqueid(userid), es.getplayername(userid))
        infos.send(userid)        
    if choice == 2:
        infos = popuplib.easymenu('Choose A Player', None, buildinfomenu)
        for player in database:
            infos.addoption(player, database[player]['name'])
        infos.send(userid)
            
def buildinfomenu(userid, choice, popupid):
    if choice not in [8,9,0]:
        tempmenu = popuplib.easymenu('%s\'s Skills'%database[choice]['name'], None, None)
        tempmenu.addoption(1, 'Level %s XP %s Credits %s'%(database[choice]['level'],database[choice]['xp'], database[choice]['credits']))
        tempmenu.addoption(2, '--------------------------')
        for x in skills:
            tempmenu.addoption(x, '%s Level %s'%(x, database[choice][x]))
        tempmenu.send(userid)

class Rank():
    '''
        sheck syntax for calling sort()
    '''
    global ranks
    def __init__(self, userid):
        if not int(es.ServerVar('arpg_enableranks')):
            return
        self.userid = userid
        self.user = playerlib.uniqueid(userid)
        if 'BOT' in self.user:
            pass
        if self.user not in ranks:
            rpgTell(self.userid, 'ranked')
            ranks[self.user] = {}
            ranks[self.user]['kills'] = 0
            ranks[self.user]['deaths'] = 0
            ranks[self.user]['rounds won'] = 0
            ranks[self.user]['rounds lost'] = 0
            ranks[self.user]['damage dealt'] = 0
            ranks[self.user]['damage taken'] = 0
            ranks[self.user]['score'] = 0
        ranks[self.user]['name'] = es.getplayername(userid)
        self.info = ranks[self.user]
    def update(self, reason, amount=None):
        if reason in self.info:
            if amount:
                self.info[reason] += int(amount)
            else:
                self.info[reason] += 1
        kills = float(self.info['kills'])
        deaths = float(self.info['deaths'])
        given = float(self.info['damage dealt'])
        taken = float(self.info['damage taken'])
        rounds = float(self.info['rounds won'])
        lost = float(self.info['rounds lost'])            
        if deaths != 0 and taken != 0 and lost != 0:
            self.info['score'] = ((float(self.info['kills']) / self.info['deaths']) * self.info['kills'] + (float(self.info['rounds won']) / self.info['rounds lost']) * self.info['rounds won'] + (float(self.info['damage dealt']) / self.info['damage taken']) * self.info['damage dealt']) / 3
        else:
            killscore = 0
            roundscore = 0
            damagescore = 0
            if deaths == 0:
                    killscore = kills / 2
            else:
                killscore = (float(self.info['kills']) / self.info['deaths']) * self.info['kills']
            if taken == 0:
                damagescore = given / 2
            else:
                damagescore = (float(self.info['damage dealt']) / self.info['damage taken']) * self.info['damage dealt']
            if lost == 0:
                roundscore = rounds / 2
            else:
                roundscore = (float(self.info['rounds won']) / self.info['rounds lost']) * self.info['rounds won']
            self.info['score'] = (killscore + damagescore + roundscore) / 3
        # Sort
        temp = []
        for player in ranks:
            temp.append(ranks[player]['score'])
        temp = reversed(sorted(temp))
        x = 0
        for score in temp:
            x += 1
            for player in ranks:
                if ranks[player]['score'] == score:
                    ranks[player]['rank'] = x
    def display(self):
        try:
            rpgMsg('rank', {'player':es.getplayername(self.userid), 'rank':self.info['rank'], 'score':self.info['score']})
        except:
            rpgMsg('not ranked yet', {'player':es.getplayername(self.userid)})
    def delete(self):
        del ranks[self.user]

class Player():
    global database
    def __init__(self, userid):
        self.userid = userid
        self.user = playerlib.uniqueid(userid)
        lang = playerlib.getPlayer(self.userid).get('lang')
        if self.user not in database:
            database[self.user] = {}
            database[self.user]['database'] = 0
            database[self.user]['level'] = 1
            database[self.user]['credits'] = int(es.ServerVar('arpg_freecredits'))
            database[self.user]['xp'] = 0
            database[self.user]['last connected'] = 0
            rpgTell(self.userid, 'welcome')
            rpgTell(self.userid, 'added')
        for x in skills:
            if x not in database[self.user]:
                database[self.user][x] = 0
        ''' We Are storing the name and steamid only to display for the admin plugin'''
        ''' We also cannot use class Player to edit an offline player for the admin plugin'''
        database[self.user]['name'] = es.getplayername(self.userid)
        database[self.user]['steamid'] = es.getplayersteamid(self.userid)
        self.info = database[self.user]
        '''
            The following intialized variables are NOT for editing the player's information inside the database!!!
            It is soley used for displaying their information!
         '''
        self.level = self.info['level']
        self.xp = self.info['xp']
        self.credits = self.info['credits']        
    def givecredits(self, amount, reason=None):
        amount = int(amount)
        self.info['credits'] += amount
        if reason:
            rpgTell(self.userid, reason, {'item':'%s Credits'%amount, 'reason':reason})
    def givelevels(self, amount, reason):
        amount = int(amount)
        if amount < 0:
            if self.info['level'] <= abs(amount):
                amount = self.info['level'] - 1
        if amount:
            self.info['level'] += amount
            rpgTell(self.userid, reason, {'item':'%s Levels'%amount, 'reason':reason})
    def givexp(self, amount, reason=None):        
        amount = int(amount)
        self.info['xp'] += amount
        if amount < 0:
            amount *= -1
        if reason:
            rpgTell(self.userid, reason, {'item':'%s XP'%amount, 'reason':reason})
        self.levelup()        
    def levelup(self):
        if int(es.ServerVar("arpg_maxlevel")) > 0 and self.info['level'] < int(es.ServerVar("arpg_maxlevel")) or int(es.ServerVar("arpg_maxlevel")) == 0:
            if self.info['xp'] >= self.info['level'] * int(es.ServerVar('arpg_levelxp')):
                self.info['xp'] -= self.info['level'] * int(es.ServerVar('arpg_levelxp'))
                self.info['level'] += 1
                self.info['credits'] += (int(es.ServerVar('arpg_levelcredits')) + self.info['level'] * int(es.ServerVar('arpg_levelcreditsinc')))
                rpgTell(self.userid, 'levelup', {'level':self.info['level'], 'xp':self.info['xp'], 'credits':self.info['credits']})
                self.levelup()
    def buy(self, skill):
        currentLevel = int(self.info[skill])
        if currentLevel < int(skills[skill]['maximum level']):
            if int(self.info['credits']) >= int(skills[skill]['Level %s'%(currentLevel + 1)]['cost']):
               self.info['credits'] -= int(skills[skill]['Level %s'%(currentLevel + 1)]['cost'])
               self.info[skill] += 1 
               rpgTell(self.userid, 'skill bought', {'name':skill,'level':self.info[skill]})
            else:
                rpgTell(self.userid, 'not enough credits')
    def sell(self, skill):
        if skills[skill]['Level %s'%self.skill(skill)]['cost']/2:
            self.givecredits(skills[skill]['Level %s'%self.skill(skill)]['cost']/2, 'selling a skill')
        else:
            self.givecredits(1, 'selling a skill')
        self.info[skill] -= 1
    def skill(self, skill):
        try:
            return database[self.user][skill]
        except:
            return 0
    def effect(self, skill):
        try:
            return skills[skill]['Level %s'%self.info[skill]]['effectiveness']
        except:
            return 0
    def query_player(self):
        self.info = database[self.user]
        self.level = self.info['level']
        self.xp = self.info['xp']
        self.credits = self.info['credits']
        rpgTell(self.userid, 'info', {'level':self.level, 'xp':self.xp, 'needed':(self.level * int(es.ServerVar('arpg_levelxp'))),  'credits':self.credits})    
    def delete(self):
        del database[self.user]

def player_spawn(ev):
    global database
    database[Player(ev['userid']).user]['last connected'] = time.time()
    Player(ev['userid']).query_player()
    
def player_hurt(ev):
    if int(es.ServerVar('arpg_teamattackxp')):
        if es.getplayerteam(ev['userid']) == es.getplayerteam(ev['attacker']):
            if ev['attacker'] != ev['userid']:
                Player(ev['attacker']).givexp(-int(es.ServerVar('arpg_teamattackxp')), 'team attack')
    if int(es.ServerVar('arpg_enableranks')):
        if not es.isbot(ev['userid']):
            Rank(ev['attacker']).update('damage dealt', ev['dmg_health'])
            Rank(ev['userid']).update('damage taken', ev['dmg_health'])

def player_death(ev):
    if es.getplayerteam(ev['attacker']) != es.getplayerteam(ev['userid']):
        Player(ev['attacker']).givexp(int(es.ServerVar('arpg_killxp')) + int(es.ServerVar('arpg_killxpinc')) * (Player(ev['attacker']).level - 1), 'getting a kill')
        if ev['headshot'] == '1':
                if int(es.ServerVar('arpg_headshotxp')):
                    Player(ev['attacker']).givexp(int(es.ServerVar('arpg_headshotxp')), 'getting a headshot')
        if int(es.ServerVar('arpg_enableranks')):
            if not es.isbot(ev['userid']):
                Rank(ev['attacker']).update('kills')
                Rank(ev['userid']).update('deaths')
    elif es.getplayerteam(ev['attacker']) == es.getplayerteam(ev['userid']) or int(ev['attacker']) == 0:
        if ev['attacker'] != ev['userid'] and int(ev['attacker']) != 0:
            if int(es.ServerVar('arpg_teamkillxp')):
                Player(ev['attacker']).givexp(-int(es.ServerVar('arpg_teamkillxp')), 'team kill')
        else:
            if int(es.ServerVar('arpg_suicidexp')):
                if ev['weapon'] != 'world': # Doesn't take XP for the client-command 'kill'
                    Player(ev['attacker']).givexp(-int(es.ServerVar('arpg_suicidexp')), 'suicide')
        
def round_end(ev):
    winner = int(ev['winner'])
    for userid in es.getUseridList():
        if int(es.getplayerteam(userid)) == winner:
            Player(userid).givexp(int(es.ServerVar('arpg_roundxp')) + int(es.ServerVar('arpg_roundxpinc')) * (Player(userid).level - 1), 'winning the round')
        if int(es.ServerVar('arpg_enableranks')):   
            if not es.isbot(userid):
                if int(es.getplayerteam(userid)) == winner:
                    Rank(userid).update('rounds won')
                if int(es.getplayerteam(userid)) != winner and int(es.getplayerteam(userid)) in [2,3]:
                    Rank(userid).update('rounds lost')                    
    if int(es.ServerVar('arpg_pruning')):
        pruned = {}
        # We need to delete them from ranks first, otherwise there is no way to check when they last connected
        if int(es.ServerVar('arpg_enableranks')):
            for player in ranks:
                if database[player]['last connected'] < time.time() - 86400 * int(es.ServerVar('arpg_pruning')):
                    pruned[database[player]['name']] = player
            for player in pruned:
                Rank(player).delete()
        pruned = {}
        for player in database:
            if database[player]['last connected'] < time.time() - 86400 * int(es.ServerVar('arpg_pruning')):
                pruned[database[player]['name']] = player
        for player in pruned:
            Player(player).delete()
            rpgMsg('pruned', {'name':player})
            
            
    str_path = open(es.getAddonPath('css_arpg') + '/players.db', 'w')
    cPickle.dump(database, str_path)
    str_path.close()    
    
    str_path = open(es.getAddonPath('css_arpg') + '/ranks.db', 'w')
    cPickle.dump(ranks, str_path)
    str_path.close()
    
def bomb_planted(ev):
    Player(ev['userid']).givexp(int(es.ServerVar('arpg_plantbombxp')), 'planting the bomb')
    
def bomb_exploded(ev):
    Player(ev['userid']).givexp(int(es.ServerVar('arpg_explodedbombxp')), 'the bomb exploding')
    
def bomb_defused(ev):
    Player(ev['userid']).givexp(int(es.ServerVar('arpg_defusedbombxp')), 'defusing the bomb')
    
def hostage_rescued(ev):
    Player(ev['userid']).givexp(int(es.ServerVar('arpg_hostagexp')), 'rescuing a hostage')

def hostage_rescued_all(ev):
    Player(ev['userid']).givexp(int(es.ServerVar('arpg_allhostagexp')), 'rescuing all hostages')
    
def hostage_killed(ev):
    Player(ev['userid']).givexp(-int(es.ServerVar('arpg_hostagekillxp')), 'hostage kill')
    
def unload():
    global database
    x = path(es.getAddonPath('css_arpg'))
    for script in x.walkfiles():
        if '.py' == script.ext and 'init' not in script.name and 'css_arpg' not in script.name:        
            y = 'css_arpg/%s'%(script.namebase)
            es.unload(y)
            
    str_path = open(es.getAddonPath('css_arpg') + '/players.db', 'w')
    cPickle.dump(database, str_path)
    str_path.close()
    
    str_path = open(es.getAddonPath('css_arpg') + '/ranks.db', 'w')
    cPickle.dump(ranks, str_path)
    str_path.close()
    
def player_say(ev):
    if ev['text'].lower() == 'rank' and int(es.ServerVar('arpg_enableranks')):
        Rank(ev['userid']).display()
    
    
def cheat():
    Player(es.getcmduserid()).givexp(100000, 'cheat')
    